%%% -*- TeX-command-extra-options: "-shell-escape" -*-
%%% Local IspellDict: en

% A chain of blocks bound by hash pointers
% Copyright (C) 2018 Jens Lechtenbörger
% License: CC BY-SA 4.0

\documentclass[convert={outext=.png}]{standalone}
% Use sans-serif by default:
% \renewcommand{\familydefault}{\sfdefault}

\usepackage{tikz}
\usetikzlibrary{calc,positioning}

\begin{document}

\begin{tikzpicture}[
  box/.style={rectangle,rounded corners,draw},
  ]
  \node (hash1) [box] {Hash: \texttt{0x00000815\ldots}};
  \node (block1) [box, below=of hash1] {\mbox{
      \begin{tabular}{lll}
        Prev: & \multicolumn{2}{l}{\texttt{0x0x0000beef\ldots}} \\
        Nonce: & \multicolumn{2}{l}{\texttt{0xf03d46a4}}\\[2ex]
        \textbf{From} & \textbf{To} & \textbf{BTC}\\\hline
        Alice & Bob & 0.42\\
        Alice & Charlie & 0.1\\
        Mallory & Eve & 10
      \end{tabular}}};
  \draw[<->,very thick] (block1) -- (hash1);

  \node (hash2) [box, right=2cm of hash1] {Hash: \texttt{0x00001234\ldots}};
  \node (block2) [box, below=of hash2] {\mbox{
      \begin{tabular}{lll}
        Prev: & \multicolumn{2}{l}{\texttt{0x00000815\ldots}} \\
        Nonce: & \multicolumn{2}{l}{\texttt{0x3e4fa000}}\\[2ex]
        \textbf{From} & \textbf{To} & \textbf{BTC}\\\hline
        Eve & Carol & 0.2\\
        Dave & Bob & 42
      \end{tabular}}};
  \draw[<->,very thick] (block2) -- (hash2);
  \draw[->,thick] ($ (block2.north west) + (0.4,-0.3) $)
    to [bend right] (hash1.south east) to [bend right] (block1);

  \node (hash3) [box, right=2cm of hash2] {Hash: \texttt{0x00002afe9\ldots}};
  \node (block3) [box, below=of hash3] {\mbox{
      \begin{tabular}{lll}
        Prev: & \multicolumn{2}{l}{\texttt{0x00001234\ldots}} \\
        Nonce: & \multicolumn{2}{l}{\texttt{0x07060504}}\\[2ex]
        \textbf{From} & \textbf{To} & \textbf{BTC}\\\hline
        Mallory & Bob & 2\\
        Alice & Bob & 0.42\\
        Alice & Charlie & 0.1\\
        Bob & Dave & 42
      \end{tabular}}};
  \draw[<->,very thick] (block3) -- (hash3);
  \draw[->,thick] ($ (block3.north west) + (0.4,-0.3) $)
    to [bend right] (hash2.south east) to [bend right] (block2);

  \node (block4) [box, below=of block3] {\mbox{
      \begin{tabular}{lll}
        Prev: & \multicolumn{2}{l}{\texttt{0x00001234\ldots}} \\
        Nonce: & \multicolumn{2}{l}{\texttt{0xa703b123}}\\[2ex]
        \textbf{From} & \textbf{To} & \textbf{BTC}\\\hline
        Mallory & Alice & 2\\
        Alice & Bob & 0.42\\
        Alice & Charlie & 0.1\\
        Bob & Dave & 42
      \end{tabular}}};
  \node (hash4) [box, below= of block4] {Hash: \texttt{0x00000076\ldots}};
  \draw[<->,very thick] (block4) -- (hash4);
  \draw[->,thick] ($ (block4.north west) + (0.4,-0.3) $)
    to [bend left] (block2);
\end{tikzpicture}
\end{document}
